package com.fp.persistence.parmas.soli;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMDOCUMENTOHABILITANTEDETALL*/
@Entity(name="TarmDocumentoHabilitanteDetall")
@Table(name="TARMDOCUMENTOHABILITANTEDETALL")
public class TarmDocumentoHabilitanteDetall extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmDocumentoHabilitanteDetall
*/
@Id
@Column(name="CODIGODETALLE" ,nullable=false, updatable=false)
/*@GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SequenceKey", parameters = {
        @Parameter(name = "name", value = "CODIGODETALLE"),//campo secuencial de la tabla
        @Parameter(name = "type", value = "java.lang.String"),// tipo de dato
        @Parameter(name = "fill", value = "0"),
        @Parameter(name = "length", value = "6")})
    @GeneratedValue(generator = "seq_id")*/
private String pk;
@Column(name="CARMA", nullable=true)

/**
* null
*/
private String carma;

@Column(name="CDOCUMENTO", nullable=true)

/**
* null
*/
private Long cdocumento;

@Column(name="CODIGOARMA", nullable=true)

/**
* null
*/
private String codigoarma;

/**Contructor por defecto*/
public TarmDocumentoHabilitanteDetall(){
}
/**Contructor de TarmDocumentoHabilitanteDetall
@param pPk Clave Primaria del entity
*/
public TarmDocumentoHabilitanteDetall(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmDocumentoHabilitanteDetall
*/
public static TarmDocumentoHabilitanteDetall find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmDocumentoHabilitanteDetall obj = pEntityManager.find(TarmDocumentoHabilitanteDetall.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmDocumentoHabilitanteDetall
@return El objeto que referencia a la Clave primaria de TarmDocumentoHabilitanteDetall
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmDocumentoHabilitanteDetall
@param pPk El objeto que referencia a la nueva Clave primaria de TarmDocumentoHabilitanteDetall
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de carma
@return valor de carma*/
public String getCarma(){
  return carma;
}
/**Fija el valor de carma
@param pCarma nuevo Valor de carma*/
public void setCarma(String pCarma){
  carma=pCarma;
}

/**Obtiene el valor de cdocumento
@return valor de cdocumento*/
public Long getCdocumento(){
  return cdocumento;
}
/**Fija el valor de cdocumento
@param pCdocumento nuevo Valor de cdocumento*/
public void setCdocumento(Long pCdocumento){
  cdocumento=pCdocumento;
}

/**Obtiene el valor de codigoarma
@return valor de codigoarma*/
public String getCodigoarma(){
  return codigoarma;
}
/**Fija el valor de codigoarma
@param pCodigoarma nuevo Valor de codigoarma*/
public void setCodigoarma(String pCodigoarma){
  codigoarma=pCodigoarma;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmDocumentoHabilitanteDetall))return false;
    TarmDocumentoHabilitanteDetall that = (TarmDocumentoHabilitanteDetall) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmDocumentoHabilitanteDetall
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmDocumentoHabilitanteDetall
*/
public Object createInstance(){
 TarmDocumentoHabilitanteDetall instance=new TarmDocumentoHabilitanteDetall();	
 return instance;
}
/**Clona la entidad TarmDocumentoHabilitanteDetall
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmDocumentoHabilitanteDetall p=(TarmDocumentoHabilitanteDetall)this.clone();
  return p;
}
}
